
#ifndef _AuxMethodMap_h
#define _AuxMethodMap_h
#include "config.h"
#ifndef OLDGCC
#pragma interface
#endif

#include "JavaMethodSignature.h"
#include "JavaTypeSignature.h"
#include "AuxMethodSignature.h"
#include <multimap.h>
#include <functional>

typedef multimap<CAuxMethodSignature, const unicode_string*, 
  less<CAuxMethodSignature> > amm_rep;
typedef amm_rep::value_type amm_entry;

// 
// Class name : CAuxMethodMap
// Description: A map from AuxMethodSignatures to the unicode_string names
//     for their functions.  
//
class CAuxMethodMap {
public:
  CAuxMethodMap(const unicode_string &class_name);
  CAuxMethodMap(const CAuxMethodMap &other);
  ~CAuxMethodMap();
  
  unicode_string AuxMethodName(CAuxMethodSignature::AuxMethodType Type,
	   const CJavaTypeSignature &Class,
	   const unicode_string *Name = 0,
	   const CJavaMethodSignature *Method = 0,
	   const deque<CJavaTypeSignature> *Throws = 0,
	   CAuxMethodSignature::WhereType WType = CAuxMethodSignature::Virtual,
	   unsigned Width = 0, unsigned Dim = 0);

  unicode_string AuxMethodName(CAuxMethodSignature::AuxMethodType Type,
			       const unicode_string &name);

  void RequireMethod(CAuxMethodSignature::AuxMethodType Type,
	   const CJavaTypeSignature &Class,
	   const unicode_string *Name = 0,
	   const CJavaMethodSignature *Method = 0,
	   const deque<CJavaTypeSignature> *Throws = 0,
	   CAuxMethodSignature::WhereType WType = CAuxMethodSignature::Virtual,
	   unsigned Width = 0, unsigned Dim = 0);

  void NameMethods();

  amm_rep::const_iterator Begin() const { return fMap.begin(); }
  amm_rep::const_iterator End() const { return fMap.end(); }

  bool ASCParse(const deque<unicode_string> &s);

protected:
  friend class CInstantiator;
  friend class CCompiler; 

  void NameForMethod(const CAuxMethodSignature &m,
		     unicode_string &setName) const;

  unicode_string fClassName;
  amm_rep fMap;

  void SetClassName(const unicode_string &name)
    { fClassName = name; }

};

#endif // _AuxMethodMap_h
