
#ifndef _MAPPED_FILE
#define _MAPPED_FILE

#pragma interface
#include "config.h"
#include <string>
extern "C" {
  #include <errno.h>
  #include <sys/types.h>
}

//
//  Class name : mapped_file
//  Description: Abstraction the common operation of pulling all/part of a 
//      file into memory, either by mmap(2) or read(2).
//
class mapped_file {
public:
  mapped_file(int fd, off_t pos, size_t len);
  mapped_file(int fd);
  
  const string& get_string() { return str; }
  bool is_valid()            { return valid; }
  void print_error();

  ~mapped_file();
  
protected:
  bool valid;
  void *buffer;
  string str;
  int my_errno;
  bool unexpected_eof;
  
  void map_file(int fd, off_t pos, size_t len);  
};

#endif
