
package polyj.lang;

public final class BoolWrap extends Primitive{
  public static final Object TrueInstance  = (Object) new BoolWrap(true);
  public static final Object FalseInstance = (Object) new BoolWrap(false);
  public static final Object Default = (Object) new BoolWrap(false);
  public boolean value;
  
  public static Object Wrap(boolean b)
  { return (b ? TrueInstance : FalseInstance); }

  public static Object Cast(Object o)
  { if (! (o instanceof BoolWrap)) throw new ClassCastException(); 
    return o; }
  
  public boolean Unwrap()
  { return value; }
   
  private BoolWrap(boolean b)
  { value = b; }
  
  public String toString()
  { return value ? "true" : "false"; }
  public int hashCode()
  { return value ? 1231 : 1237; } 
  
  public long longValue()
  { return value ? 1 : 0; }
  public double doubleValue()
  { return value ? 1.0 : 0.0; }
}
